import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 职称信息服务对象基类
 *
 * @export
 * @class HRTechnicalTitleServiceBase
 * @extends {EntityServie}
 */
export default class HRTechnicalTitleServiceBase extends EntityService {

    /**
     * Creates an instance of  HRTechnicalTitleServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  HRTechnicalTitleServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof HRTechnicalTitleServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='hrtechnicaltitle';
        this.APPDEKEY = 'hrtechnicaltitleid';
        this.APPDENAME = 'hrtechnicaltitles';
        this.APPDETEXT = 'hrtechnicaltitlename';
        this.APPNAME = 'pim';
        this.SYSTEMNAME = 'ibizhumanresources';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && context.hrtechnicaltitle){
            let res:any = Http.getInstance().get(`/hremployees/${context.hremployee}/hrtechnicaltitles/${context.hrtechnicaltitle}/select`,isloading);
            
            return res;
        }
            let res:any = Http.getInstance().get(`/hrtechnicaltitles/${context.hrtechnicaltitle}/select`,isloading);
            
            return res;
    }

    /**
     * Create接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async Create(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && true){
            let masterData:any = {};
            Object.assign(data,masterData);
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            let tempContext:any = JSON.parse(JSON.stringify(context));
            let res:any = await Http.getInstance().post(`/hremployees/${context.hremployee}/hrtechnicaltitles`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
        if(!data.srffrontuf || data.srffrontuf !== "1"){
            data[this.APPDEKEY] = null;
        }
        if(data.srffrontuf){
            delete data.srffrontuf;
        }
        let tempContext:any = JSON.parse(JSON.stringify(context));
        let res:any = await Http.getInstance().post(`/hrtechnicaltitles`,data,isloading);
        
        return res;
    }

    /**
     * Update接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async Update(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && context.hrtechnicaltitle){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().put(`/hremployees/${context.hremployee}/hrtechnicaltitles/${context.hrtechnicaltitle}`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().put(`/hrtechnicaltitles/${context.hrtechnicaltitle}`,data,isloading);
            
            return res;
    }

    /**
     * Remove接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async Remove(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && context.hrtechnicaltitle){
            let res:any = Http.getInstance().delete(`/hremployees/${context.hremployee}/hrtechnicaltitles/${context.hrtechnicaltitle}`,isloading);
            return res;
        }
            let res:any = Http.getInstance().delete(`/hrtechnicaltitles/${context.hrtechnicaltitle}`,isloading);
            return res;
    }

    /**
     * Get接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async Get(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && context.hrtechnicaltitle){
            let res:any = await Http.getInstance().get(`/hremployees/${context.hremployee}/hrtechnicaltitles/${context.hrtechnicaltitle}`,isloading);
            
            return res;
        }
            let res:any = await Http.getInstance().get(`/hrtechnicaltitles/${context.hrtechnicaltitle}`,isloading);
            
            return res;
    }

    /**
     * GetDraft接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async GetDraft(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && true){
            let res:any = await Http.getInstance().get(`/hremployees/${context.hremployee}/hrtechnicaltitles/getdraft`,isloading);
            res.data.hrtechnicaltitle = data.hrtechnicaltitle;
            
            return res;
        }
        let res:any = await  Http.getInstance().get(`/hrtechnicaltitles/getdraft`,isloading);
        res.data.hrtechnicaltitle = data.hrtechnicaltitle;
        
        return res;
    }

    /**
     * CheckKey接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async CheckKey(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && context.hrtechnicaltitle){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hremployees/${context.hremployee}/hrtechnicaltitles/${context.hrtechnicaltitle}/checkkey`,data,isloading);
            
            return res;
        }
            let res:any = Http.getInstance().post(`/hrtechnicaltitles/${context.hrtechnicaltitle}/checkkey`,data,isloading);
            return res;
    }

    /**
     * Save接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async Save(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && context.hrtechnicaltitle){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hremployees/${context.hremployee}/hrtechnicaltitles/${context.hrtechnicaltitle}/save`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().post(`/hrtechnicaltitles/${context.hrtechnicaltitle}/save`,data,isloading);
            
            return res;
    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hremployees/${context.hremployee}/hrtechnicaltitles/fetchdefault`,tempData,isloading);
            return res;
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        let res:any = Http.getInstance().get(`/hrtechnicaltitles/fetchdefault`,tempData,isloading);
        return res;
    }

    /**
     * FetchHigh接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async FetchHigh(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hremployees/${context.hremployee}/hrtechnicaltitles/fetchhigh`,tempData,isloading);
            return res;
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        let res:any = Http.getInstance().get(`/hrtechnicaltitles/fetchhigh`,tempData,isloading);
        return res;
    }

    /**
     * FetchJunior接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async FetchJunior(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hremployees/${context.hremployee}/hrtechnicaltitles/fetchjunior`,tempData,isloading);
            return res;
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        let res:any = Http.getInstance().get(`/hrtechnicaltitles/fetchjunior`,tempData,isloading);
        return res;
    }

    /**
     * FetchMiddle接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async FetchMiddle(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hremployees/${context.hremployee}/hrtechnicaltitles/fetchmiddle`,tempData,isloading);
            return res;
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        let res:any = Http.getInstance().get(`/hrtechnicaltitles/fetchmiddle`,tempData,isloading);
        return res;
    }

    /**
     * FetchSenior接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRTechnicalTitleServiceBase
     */
    public async FetchSenior(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hremployee && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hremployees/${context.hremployee}/hrtechnicaltitles/fetchsenior`,tempData,isloading);
            return res;
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        let res:any = Http.getInstance().get(`/hrtechnicaltitles/fetchsenior`,tempData,isloading);
        return res;
    }
}